<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/categories/main.lib.php";
	require_once GEKKO_ROOT."modules/users/main.lib.php";
	require_once GEKKO_ROOT."lib/format.lib.php";

	$action = _ext("action", 2);
	$page = _ext("page", 2);
	$id = _ext("id", 3);

	switch ($action) {
		case "edit":
			if (!$id) break;

			$categories = getCategories(true);

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "blog/index.admin.tpl");
			$tpl->insert("BLOG.FORM", "blog/blog.form.tpl");

			$db->query("
				SELECT
					ID, UserID, Category, Icon, Title, Content, Footer, CreationTime, Status, AllowComments
				FROM ".db_table("blog")." WHERE ID = '".$id."'
			");

			if (!$db->num_rows()) break;

			$row = $db->fetch_row();
			saneHTML($row);

			$rtb = new rtbEditor($row["Content"]);
			$rtb->setSize(350, 300);

			$row["Content"] = user_env_vars($row["Content"]);
			$row["BLOCK_TITLE"] = _l("L_BLOG");
			$row["BLOCK_SUBTITLE"] = _l("L_EDIT");
			$row["BLOCK_ICON"] = mkIcon("blog", 16);
			$row["ICONCHOOSER"] = mkIconChooser(16, $row["Icon"]);
			$row["STATUS.SEL"] = mkSelect(array(_l("L_DRAFT"), _l("L_PUBLISHED")), $row["Status"], "status");
			$row["CATEGORIES.SEL"] = mkSelect($categories, $row["Category"], "category");
			$row["OPTIONS"] = mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), $row["AllowComments"]);
			$row["ACTION"] = "edit";
			$row["RETURN"] = "../../index.php/admin/blog";
			$row["RTBEDITOR"] = $rtb->make();

			$tpl->set_arr($row);

			$mcBuff = $tpl->make();

		break;
		default:

			$categories = getCategories(true);

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "blog/index.admin.tpl");
			$tpl->insert("BLOG.FORM", "blog/blog.form.tpl");

			$entries = 0;

			$pager = $db->pager (
				"SELECT ID FROM ".db_table("blog")." ORDER BY Status ASC, CreationTime DESC ",
				"index.php/admin/blog/%p", $page, conf::getkey("blog", "items_per_admin_page")
			);

			$db->query ("
				SELECT ID, UserID, Category, Icon, Title, Content, CreationTime, Status
				FROM ".db_table("blog")."
				ORDER BY Status ASC, CreationTime DESC ".$pager["sql"]."
			", __FILE__, __LINE__);

			$entries = $db->num_rows();

			while ($row = $db->fetch_row()) {

				saneHTML($row, "Content");

				if (!$row["Status"]) $row["Category"] .= " ("._l("L_DRAFT").")";
				$row["Icon"] = mkIcon($row["Icon"], 16);
				$row["Category"] = getCategoryByID($row["Category"]);
				$row["Author"] = getUserByID($row["UserID"]);
				$row["Introduction"] = mkIntro($row["Content"]);
				$row["Created"] = dateFormat($row["CreationTime"]);

				$row["Actions"] = Array();
				$row["Actions"][] = mkLink("index.php/admin/blog/edit/".$row["ID"], _l("L_EDIT"));
				$row["Actions"][] = mkLink("modules/blog/main.act.php?action=delete&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1);
				if (!$row["Status"]) {
					$row["Actions"][] = mkLink("modules/blog/main.act.php?action=publish&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_PUBLISH"));
					$row["Title"] .= " ("._l("L_DRAFT").")";
				}
				$row["Actions"] = mkButtonDisplay($row["Actions"]);

				$tpl->set_arr(
					$row,
					"ENTRY"
				);
				$tpl->saveBuff("ENTRY");
			}

			// Loading and setting up rtbEditor
			$rtb = new rtbEditor();
			$rtb->setSize(350, 300);

			$tpl->set_arr(
				Array (
					"BLOCK_TITLE" => _l("L_BLOG"),
					"BLOCK_SUBTITLE" => _l("L_COMPOSE"),
					"BLOCK_ICON" => mkIcon("blog.png", 16),
					"ICONCHOOSER" => mkIconChooser(16, "blog.png"),
					"STATUS.SEL" => mkSelect(array(_l("L_DRAFT"), _l("L_PUBLISHED")), 1, "status"),
					"CATEGORIES.SEL" => mkSelect($categories, null, "category"),
					"ENTRIES" => $entries,
					"ACTION" => "post",
					"OPTIONS" =>  mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), 1),
					"TITLE" => "",
					"CONTENT" => "",
					"FOOTER" => "",
					"ID" => 0,
					"RETURN" => "",
					"ENTRY_PAGER" => $pager["html"],
					"RTBEDITOR" => $rtb->make()
				)
			);
			$mcBuff = $tpl->make();
		break;
	}


?>