<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";
	require_once GEKKO_ROOT."lib/file.lib.php";
	require_once GEKKO_ROOT."lib/image.lib.php";
	require_once GEKKO_ROOT."modules/downloads/main.lib.php";

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	gpGet("action", 1);
	gpGet("id", 1);
	gpGet("return", 1);

	if (!is_admin())
		abort(accessDenied());

	mkworkdir(GEKKO_ROOT."data/downloads/");

	switch ($action) {
		case "delete_item":
			execWithEach($id, "deleteDownloadItem");
		break;
		case "delete":
			execWithEach($id, "deleteDownloadsCat");
		break;
		case "enable":
			downloadsCatSetStatus($id, "1");
		break;
		case "disable":
			downloadsCatSetStatus($id, "0");
		break;
		case "edit":
			gpGlobalize("id, status, categorylink, title, description, auth_access, filesize");

			requireVars($id, $title);

			// thumbnail required
			if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
				$thumb = file_get("local_file", "remote_file", "temp");
				if ($thumb) {
					$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
					$icon = $thumb["url"];
				} else {
					abort(_l("L_ERROR"));
				}
				// deleting old thumbnail
				$db->query("SELECT Thumbnail FROM ".db_table("download")." WHERE ID = '{$id}'", __FILE__, __LINE__);
				$row = $db->fetch_row();
				@unlink(GEKKO_ROOT.$row["Thumbnail"]);
			} else {
				$thumb = false;
			}

			$db->query("UPDATE ".db_table("download")." SET
				Title = '{$title}',
				Description = '{$description}',
				CategoryLink = '{$categorylink}',
				Status = '{$status}',
				AuthorID = '{$User["ID"]}',
				Filesize = '{$filesize}',
				LastUpdated = '".time()."',
				".($thumb ? "Thumbnail = '{$thumb["url"]}'," : "")."
				".($thumb ? "ThumbnailSize = '{$thumb["width"]}x{$thumb["height"]}'," : "")."
				auth_Access = '{$auth_access}'
			WHERE ID = '{$id}'
			", __FILE__, __LINE__);

			slog("downloads: category '$id' was updated", "actions", 1);
		break;
		case "create":

			gpGlobalize("status, categorylink, title, description, auth_access");

			requireVars($title);

			// thumbnail required
			if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
				$thumb = file_get("local_file", "remote_file", "temp");
				if ($thumb) {
					$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
				} else {
					abort(_l("L_ERROR"));
				}
			}

			$db->query ("
			INSERT INTO ".db_table("download")."
				(
					ID,
					CategoryLink,
					Title,
					Description,
					Status,
					Thumbnail,
					ThumbnailSize,
					AuthorID,
					CreationTime,
					LastUpdated,
					auth_Access
				)
					VALUES
				(
					'".$db->free_id("download")."',
					'{$categorylink}',
					'{$title}',
					'{$description}',
					'{$status}',
					'".(isset($thumb["url"]) ? $thumb["url"] : "")."',
					'".(isset($thumb["url"]) ? $thumb["width"]."x".$thumb["height"] : "")."',
					'{$User["ID"]}',
					'".time()."',
					'".time()."',
					'{$auth_access}'
				)
			", __FILE__, __LINE__);

			slog("downloads: new sub category '$title' filed under catid '$categorylink'", "actions", 2);
		break;
		case "edit_item":

			gpGlobalize("id, downloadlink, title, description, link_only,
			downloadurl, thumbnail, allowcomments");

			requireVars($id, $title, $downloadlink);

			// changed media
			$media = Array();
			if ((!$link_only) && ($_POST["remote_media"] || $_FILES["local_media"]["size"])) {
				// getting file by url or submission
				$media = file_get("local_media", "remote_media", "data/downloads");
				if (!file_exists($media["abs_loc"]))
					abort(_l("E_ERROR"));
			} elseif ($link_only && $_POST["remote_media"]) {
				// only linking
				$media["rel_loc"] = $_POST["remote_media"];
			}
			if (!$title)
				$title = beauty_basename($media["rel_loc"]);

			// changed thumbnail
			$thumb = Array();
			if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
				$thumb = file_get("local_file", "remote_file", "data/gallery");
				if ($thumb)
					$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
			}

			if ($media || $thumb) {
				// deleting old files
				$db->query("SELECT Thumbnail, DownloadURL FROM ".db_table("download_item")."
				WHERE ID = '$id'", __FILE__, __LINE__);
				$row = $db->fetch_row();
				if ($media) @unlink(GEKKO_ROOT.$row["DownloadURL"]);
				if ($thumb) @unlink(GEKKO_ROOT.$row["Thumbnail"]);
			}

			$db->query("UPDATE ".db_table("download_item")." SET
				DownloadLink = '{$downloadlink}',
				Title = '{$title}',
				Description = '{$description}',
				Thumbnail = '".(isset($thumb["url"]) ? $thumb["url"] : $thumbnail)."',
				".($thumb ? "ThumbnailSize = '{$thumb["width"]}x{$thumb["height"]}'," : "")."
				DownloadURL = '".(isset($media["rel_loc"]) ? $media["rel_loc"] : $downloadurl)."',
				AuthorID = '{$User["ID"]}',
				LastUpdated = '".time()."',
				AllowComments = '{$allowcomments}'
			WHERE ID = '{$id}'", __FILE__, __LINE__);

			slog("downloads: item '$id' was updated", "actions", 1);
		break;
		case "add_item":

			unset($size);

			gpGlobalize("downloadlink, title, description, link_only, allowcomments, filesize");

			requireVars($downloadlink);

			$media = Array();

			// media is required
			if ((!$link_only) && ($_POST["remote_media"] || $_FILES["local_media"]["size"])) {
				// saving media
				$media = file_get("local_media", "remote_media", "data/downloads");

				if (!file_exists($media["abs_loc"]))
					abort(_l("E_ERROR"));

			} elseif ($link_only && $_POST["remote_media"]) {
				// only linking
				$media["rel_loc"] = $_POST["remote_media"];
			} else {
				abort(_l("E_INSUFFICIENT_DATA"));
			}

			if (!$title)
				$title = beauty_basename($media["rel_loc"]);

			// when thumbnail is provided
			if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
				$thumb = file_get("local_file", "remote_file", "data/gallery");
				if ($thumb) {
					if ($link_only) {
						// saving image size before resizing
						$media["size"] = imagesize($thumb["abs_loc"]);
					}
					$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
				}
			} else {
				$thumb = false;
			}

			// getting filesize
			if (!$filesize) {
				$filesize = r_filesize($media["rel_loc"]);
				if (!$filesize && isset($media["abs_loc"]))
					$filesize = r_filesize($media["abs_loc"]);
			}

			$db->query ("
			INSERT INTO ".db_table("download_item")."
				(
					ID,
					DownloadLink,
					Title,
					Description,
					Thumbnail,
					ThumbnailSize,
					DownloadURL,
					AuthorID,
					CreationTime,
					LastUpdated,
					FileSize,
					allowComments
				)
					VALUES
				(
					'".$db->free_id("download_item")."',
					'{$downloadlink}',
					'{$title}',
					'{$description}',
					'".($thumb ? $thumb["url"] : "")."',
					'".($thumb ? $thumb["width"]."x".$thumb["height"] : "")."',
					'{$media["rel_loc"]}',
					'{$User["ID"]}',
					'".time()."',
					'".time()."',
					'{$filesize}',
					'{$allowcomments}'
				)
			", __FILE__, __LINE__);

			slog("downloads: added item to downloads category '$title'", "actions", 2);
		break;
		default:
			abort(_l("L_UNDEFINED_ACTION"));
		break;
	}

	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>