<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."lib/remote.lib.php";
	require_once GEKKO_ROOT."lib/file.lib.php";

	function r_filesize($file) {
		if (file_exists($file)) {
			return filesize($file);
		} else {
			$uri = parseURI($file);
			switch ($uri["proto"]) {
				case "http":
					$conn = new httpSession($uri["host"], $uri["port"] ? $uri["port"] : 80);
					$conn->sendRequest($uri["file"]);
					$headers = $conn->getHeaders();
					$conn->close();
					preg_match("/content-length:\s*(\d*)/si", $headers, $size);
					return isset($size[1]) ? $size[1] : 0;
				break;
			}
		}
		return 0;
	}

	function countDownloadItems($id = 0) {
		$q = $GLOBALS["db"]->query("SELECT ID FROM ".db_table("download_item")."
		WHERE DownloadLink = '{$id}'", __FILE__, __LINE__, true);
		return intval($GLOBALS["db"]->num_rows($q));
	}

	function getDownloadCats() {
		$q = $GLOBALS["db"]->query("SELECT ID, Title FROM ".db_table("download")."
		ORDER BY Title ASC", __FILE__, __LINE__, true);
		$buff = Array();
		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			$buff[$row["ID"]] = $row["Title"];
		}
		return $buff;
	}
	function deleteDownloadsCat($id) {

		$q = $GLOBALS["db"]->query("SELECT ID FROM ".db_table("download_item")."
		WHERE DownloadLink = '{$id}'", __FILE__, __LINE__, true);

		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			deleteDownloadItem($row["ID"]);
		}

		$q = $GLOBALS["db"]->query("SELECT
		Thumbnail FROM ".db_table("download")." WHERE ID = '{$id}'", __FILE__, __LINE__, true);
		$r = $GLOBALS["db"]->fetch_row($q);

		@unlink(GEKKO_ROOT.$row["Thumbnail"]);

		slog("downloads: deleted category '$id' with all linked contents", "actions", 1);

		return $GLOBALS["db"]->query ("DELETE FROM ".db_table("download")." WHERE ID='{$id}'", __FILE__, __LINE__, true);
	}
	function deleteDownloadItem($id) {
		require_once GEKKO_ROOT."modules/comments/main.lib.php";

		// deleting comments
		deleteComments("downloads", $id);

		$q = $GLOBALS["db"]->query("SELECT Thumbnail, DownloadURL FROM ".db_table("download_item")." WHERE ID = '{$id}'", __FILE__, __LINE__, true);
		$r = $GLOBALS["db"]->fetch_row($q);

		// deleting media
		@unlink(GEKKO_ROOT.$r["Thumbnail"]);
		@unlink(GEKKO_ROOT.$r["DownloadURL"]);

		slog("downloads: deleted item '$id'", "actions", 1);

		return $GLOBALS["db"]->query ("DELETE FROM ".db_table("download_item")." WHERE ID='{$id}'", __FILE__, __LINE__, true);
	}
	function downloadsCatSetStatus($id, $status) {
		slog("downloads: status of '$id' changed to '$status'", "actions", 2);
		return $GLOBALS["db"]->query ("UPDATE ".db_table("download")." SET Status = '{$status}' WHERE ID='{$id}'", __FILE__, __LINE__, true);
	}
	function downloadsAllowComment($thread) {
		// checking item
		$q = $GLOBALS["db"]->query("SELECT DownloadLink FROM ".db_table("download_item")." WHERE ID = '{$thread}' AND AllowComments = '1'", __FILE__, __LINE__, true);
		$row = $GLOBALS["db"]->fetch_row($q);

		// checking access
		$q = $GLOBALS["db"]->query("SELECT auth_Access FROM ".db_table("download")." WHERE ID = '{$row["DownloadLink"]}' AND Status = '1'");
		$row = $GLOBALS["db"]->fetch_row($q);

		return $GLOBALS["db"]->num_rows($q) ? gauth($row["auth_Access"]) : false;
	}
	function allowedDownloadCategories() {
		$global = getAllowedCategories();

		$allowed = Array();
		$q = $GLOBALS["db"]->query("SELECT ID, auth_Access, CategoryLink
		FROM ".db_table("download")." WHERE Status = '1'", __FILE__, __LINE__, true);
		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			if (gauth($row["auth_Access"]) && (isset($global[$row["CategoryLink"]])))
				$allowed[$row["ID"]] = $row["ID"];
		}
		return $allowed;
	}
	function downloadFixRow(&$row, $is_item = false) {
		$row["TITLE_ID"] = urlencode($row["Title"]);

		if ($row["Thumbnail"])
			list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["ThumbnailSize"]);

		$row["MODIFIED"] = dateFormat($row["LastUpdated"]);
		$row["AUTHOR"] = getUserById($row["AuthorID"]);

		if (!$is_item)
			$row["ITEMS"] = countDownloadItems($row["ID"]);
	}
?>