<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."lib/file.lib.php";
	require_once GEKKO_ROOT."lib/format.lib.php";
	require_once GEKKO_ROOT."modules/files/main.lib.php";

	$action = isset($_GET["action"]) ? $_GET["action"] : false;

	/*
		TODO: $browse
	*/
	//$browse = isset($_GET["browse"]) ? $_GET["browse"] : false;
	$browse = false;

	// "/admin/files/" length = 13
	if ($browse) {
		$dir = $browse;
	} else {
		$dir = trim(substr($_SERVER["PATH_INFO"], 13), "/");
		$dir = rtrim("data/files/{$dir}","/");
	}

	if (!file_exists(GEKKO_ROOT.$dir)) {

		$mcBuff = _l("L_FILE_DOESNT_EXISTS");

	} elseif (is_dir(GEKKO_ROOT.$dir) && !$action) {

		$basedir = basename($dir);

		/* directory listing */

		$tpl = new ContentBlock();
		$tpl->insert("BLOCK_CONTENT", "files/index.admin.tpl");
		$tpl->insert("UPLOAD.FORM", "files/upload.form.tpl");

		$dir .= "/";

		// fetching directory contents
		$buff = listdir(GEKKO_ROOT.$dir);

		// directories first
		$dirs = Array();
		$files = Array();
		foreach ($buff as $file) {
			$path = GEKKO_ROOT.$dir.$file;
			(is_dir($path)) ? ($dirs[] = $file) : ($files[] = $file);
		}
		$items = array_merge($dirs, $files);

		// total size counter
		$total_size = 0;

		foreach ($items as $file) {
			$path = GEKKO_ROOT.$dir.$file;

			$is_dir = is_dir($path);

			$data = Array (
				"FILENAME" => $file,
				"ICON" => mkFileIcon($path),
				"PERMS" => readable_perms(fileperms($path)),
				"FILESIZE" => size_r($size = filesize($path)),
				"FILETYPE" => get_file_type($path),
				"MODIFIED" => dateFormat(filemtime($path)),
				"FILELINK" => (is_dir($path) ? $basedir."/" : _l("C_SITE.REL_URL").$dir)."$file"
				//"FILELINK" => (($browse) ? "files?browse=".urlencode("$browse/$file") : (is_dir($path) ? "files/" : _l("C_SITE.REL_URL").$dir).$file)
			);

			$data["ACTIONS"] = Array();
			if (is_writable($path)) {
				if ($browse) {
					// todo
					$data["ACTIONS"][] = mkLink("index.php/admin/files?action=edit&browse=".urlencode("$browse/$file")."", _l("L_EDIT"));
				} else {
					$data["ACTIONS"][] = mkLink("index.php".rtrim($_SERVER["PATH_INFO"], "/")."/$file?action=edit", _l("L_EDIT"));
					$data["ACTIONS"][] = mkLink("modules/files/main.act.php?action=delete&file=".urlencode($dir.$file)."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, true);
				}
			}
			$data["ACTIONS"] = mkButtonDisplay($data["ACTIONS"]);

			$tpl->set_arr($data, "FILE");
			$tpl->saveBuff("FILE");

			$total_size += (!$is_dir)*$size;
		}

		$tpl->set_arr (
			Array (
				"PATH" => $dir,
				"ACTION" => "upload",
				"BLOCK_TITLE" => _l("L_FILES"),
				"BLOCK_SUBTITLE" => "./".$dir,
				"BLOCK_ICON" => mkIcon("files.png", 16),
				"RETURN" => "",
				"FILES" => count($files),
				"ITEMS" => count($items),
				"DIRS" => count($dirs),
				"TOTAL_SIZE" => size_r($total_size)
			)
		);

		$mcBuff = $tpl->make();

	} elseif ($action == "edit") {

		$file = $dir;

		$path = GEKKO_ROOT.$file;

		$tpl = new ContentBlock();
		$tpl->insert("BLOCK_CONTENT", "files/file.form.tpl");

		// permissions
		$perms = substr(readable_perms(fileperms($path)), 1);
		$level = Array("U", "G", "O");
		$modes = Array("r", "w", "x");
		$buff = Array();
		for ($i = 0; $i < 3; $i++) {
			$pblock = substr($perms, $i*3, 3);
			foreach ($modes as $j => $mode) {
				$e = ($mode == substr($pblock, $j, 1));
				$k = strtoupper($level[$i].$mode);
				$tpl->set(strtoupper("P".$k), mkCheckBox("perm[$k]", null, $e));
			}
		}

		$tpl->set_Arr (
			Array (
				"BLOCK_ICON" => mkFileIcon($file, 16),
				"BLOCK_TITLE" => basename($file),
				"PATH" => $file,
				"FILE" => basename($file),
				"PARENT" => dirname($file),
				"ACTION" => "fileprop",
				"RETURN" => ""
			)
		);

		$mcBuff = $tpl->make();
	} elseif ($browse) {
		$file = GEKKO_ROOT.$browse;
		if (file_exists($file)) {
			$fp = fopen($file, "rb");
			header("Content-Type: application/octect-stream");
			header("Content-Length: ".filesize($file)."");
			abort(fpassthru($fp));
		}
	}


?>