<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."lib/format.lib.php";
	require_once GEKKO_ROOT."lib/file.lib.php";
	require_once GEKKO_ROOT."modules/files/main.lib.php";

	$tpl = new ContentBlock();
	$tpl->insert("BLOCK_CONTENT", "files/index.tpl");

	$dir = trim(substr($_SERVER["PATH_INFO"], 7), "/");
	$dir = rtrim("data/files/{$dir}","/")."/";

	$basedir = basename($dir);

	// preventing directory scalation
	if (ereg("\.\.\/", $dir)) $dir = "data/files/";

	// scanning directory contents
	$buff = listdir(GEKKO_ROOT.$dir);

	// directories first
	$dirs = Array();
	$files = Array();
	foreach ($buff as $file) {
		$path = GEKKO_ROOT.$dir.$file;
		(is_dir($path)) ? ($dirs[] = $file) : ($files[] = $file);
	}
	$items = array_merge($dirs, $files);

	// total size counter
	$total_size = 0;

	foreach ($items as $file) {
		$path = GEKKO_ROOT.$dir.$file;

		$is_dir = is_dir($path);

		$data = Array (
			"FILENAME" => $file,
			"ICON" => mkFileIcon($path, 48),
			//"PERMS" => readable_perms(fileperms($path)),
			"FILESIZE" => size_r($size = filesize($path)),
			"FILETYPE" => get_file_type($path),
			"MODIFIED" => dateFormat(filemtime($path)),
			"FILELINK" => (is_dir($path) ? $basedir."/" : _l("C_SITE.REL_URL").$dir)."$file"
			//"FILELINK" => _l("C_SITE.REL_URL").($is_dir ? "index.php/files/" : $dir).$file
		);

		$total_size += (!$is_dir)*$size;

		$tpl->set_arr($data, "FILE");
		$tpl->saveBuff("FILE");
	}

	$tpl->set_arr (
		Array (
			"BLOCK_TITLE" => _l("L_FILES"),
			"BLOCK_SUBTITLE" => "./".$dir,
			"BLOCK_ICON" => mkIcon("files.png", 16),
			"FILES" => count($files),
			"ITEMS" => count($items),
			"DIRS" => count($dirs),
			"TOTAL_SIZE" => size_r($total_size)
		)
	);

	$mcBuff = $tpl->make();


	// saving buffer into modCore
	$mc->save($mcBuff);
?>