<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	$action = _ext("action", 2);
	$subact = _ext("subact", 3);
	//
	$id = _ext("id", 4);
	$category = _ext("category", 4);

	$category_order = $forum_order = Array(_l("L_BOTTOM"), _l("L_TOP"));

	function forums_getCategories() {
		$r = array();
		$q = $GLOBALS["db"]->query("SELECT ID, Name FROM ".db_table("forum_category")."
		ORDER BY OrderID ASC", __FILE__, __LINE__, true);
		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			saneHTML($row);
			$r[$row["ID"]] = $row["Name"];
		}
		return $r;
	}

	switch ($action) {
		case "forum":
			switch($subact) {
				case "create":
					$tpl = new ContentBlock();
					$tpl->insert("BLOCK_CONTENT", "forums/forum.form.tpl");

					$tpl->set_arr(
						Array (
							"BLOCK_TITLE" => _l("L_FORUMS"),
							"BLOCK_SUBTITLE" => _l("L_CREATE_FORUM"),
							"BLOCK_ICON" => mkIcon("categories.png", 16),
							"ICONCHOOSER" => mkIconChooser(16, "forum.png"),
							"STATUS.SEL" => booleanStatus(1, "status"),
							"ORDERID.SEL" => mkSelect($forum_order, "0", "orderid"),
							"CATEGORIES.SEL" => mkSelect(forums_getCategories(), $category ? $category : 1, "categoryid"),
							"NAME" => "",
							"DESCRIPTION" => "",
							"ACTION" => "new_forum",
							"RETURN" => ""
						)
					);

					$mcBuff = $tpl->make();
				break;
				case "edit":
					$tpl = new ContentBlock();
					$tpl->insert("BLOCK_CONTENT", "forums/forum.form.tpl");

					$db->query("SELECT ID, CategoryID, OrderID, Icon, Name, Description,
					Status FROM ".db_table("forum_forum")." WHERE ID = '{$id}'", __FILE__, __LINE__);

					if ($db->num_rows()) {
						$row = $db->fetch_row();

						saneHTML($row);

						$tpl->set_arr($row);

						$tpl->set_arr(
							Array (
								"BLOCK_TITLE" => _l("L_FORUMS"),
								"BLOCK_SUBTITLE" => _l("L_EDIT_FORUM"),
								"BLOCK_ICON" => mkIcon("categories.png", 16),
								"ICONCHOOSER" => mkIconChooser(16, $row["Icon"]),
								"STATUS.SEL" => booleanStatus($row["Status"], "status"),
								"ORDERID.SEL" => mkSelect($forum_order, $row["OrderID"], "orderid"),
								"CATEGORIES.SEL" => mkSelect(forums_getCategories(), $row["CategoryID"], "categoryid"),
								"ACTION" => "edit_forum",
								"RETURN" => "../../index.php/admin/forums"
							)
						);

						$mcBuff = $tpl->make();
					}
				break;
			}
		break;
		case "category":
			switch ($subact) {
				case "edit":
					$id = _ext("id");

					/* order */
					$category_order = Array();
					$db->query("SELECT OrderID FROM ".db_table("forum_category")."
					ORDER BY OrderID ASC", __FILE__, __LINE__);

					while ($row = $db->fetch_row()) {
						$category_order[$row["OrderID"]] = $row["OrderID"];
					}

					$tpl = new ContentBlock();
					$tpl->insert("BLOCK_CONTENT", "forums/index.admin.tpl");
					$tpl->insert("CATEGORY.FORM", "forums/category.form.tpl");
					$tpl->insert("FORUM.FORM", "forums/category.form.tpl");

					$db->query("SELECT ID, Icon, OrderID, Name, Description, Status,
					auth_Access, auth_Post
					FROM ".db_table("forum_category")." WHERE ID = '{$id}'", __FILE__, __LINE__);

					$row = $db->fetch_row();
					saneHTML($row);

					$row["BLOCK_TITLE"] = _l("L_FORUMS");
					$row["BLOCK_SUBTITLE"] = _l("L_EDIT_CATEGORY");
					$row["BLOCK_ICON"] = mkIcon("categories.png", 16);

					$row["ICONCHOOSER"] = mkIconChooser(16, $row["Icon"]);
					$row["STATUS.SEL"] = booleanStatus($row["Status"], "status");
					$row["ORDERID.SEL"] = mkSelect($category_order, $row["OrderID"], "orderid");
					$row["ACTION"] = "edit_category";
					$row["AUTH_ACCESS"] = mkAuthSelect($row["auth_Access"], "auth_access");
					$row["AUTH_POST"] = mkAuthSelect($row["auth_Post"], "auth_post");
					$row["RETURN"] = "../../index.php/admin/forums";

					$tpl->set_arr ($row);

					$mcBuff = $tpl->make();

				break;
			}
		break;
		default:

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "forums/index.admin.tpl");
			$tpl->insert("CATEGORY.FORM", "forums/category.form.tpl");

			$db->query("SELECT ID, Icon, Name, Description, Status, auth_Access
			FROM ".db_table("forum_category")." ORDER BY OrderID ASC",
			__FILE__, __LINE__);

			$categories = $db->num_rows();

			while ($row = $db->fetch_row()) {
				saneHTML($row);

				/* fetching forums for this category */
				$q = $db->query("SELECT ID, Icon, Name, Description, Status,
				MessageCount, TopicCount
				FROM ".db_table("forum_forum")."
				WHERE CategoryID = '{$row["ID"]}' ORDER BY OrderID ASC",
				__FILE__, __LINE__, true);

				$tpl->reset("CATEGORY.FORUM");
				if ($db->num_rows($q)) {
					while ($row2 = $db->fetch_row($q)) {
						$tpl->reset("CATEGORY.FORUM", true);

						$row2["Icon"] = mkIcon($row2["Icon"], 16);

						$row2["Actions"] = Array (
							mkLink("modules/forums/main.act.php?action=move_forum&where=up&id=".$row2["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_MOVE_UP"), false),
							mkLink("modules/forums/main.act.php?action=move_forum&where=down&id=".$row2["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_MOVE_DOWN"), false),
							mkLink("index.php/admin/forums/forum/edit?id=".$row2["ID"], _l("L_EDIT")),
							mkLink("modules/forums/main.act.php?action=delete_forum&id=".$row2["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, true)
						);
						if (!$row2["Status"]) $row2["Actions"][] = mkLink("modules/forums/main.act.php?action=enable_forum&id=".$row2["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_ENABLE"));
						$row2["Actions"] = mkButtonDisplay($row2["Actions"]);

						$tpl->set_arr($row2, "CATEGORY.FORUM");

						$tpl->savebuff("CATEGORY.FORUM");
					}
				} else {
					$tpl->hideBlock("CATEGORY.FORUM");
					//gdebug($tpl);
				}

				$row["Icon"] = mkIcon($row["Icon"], 16);

				$row["Actions"] = Array (
					mkLink("modules/forums/main.act.php?action=move_category&where=up&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_MOVE_UP"), "up.png"),
					mkLink("modules/forums/main.act.php?action=move_category&where=down&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_MOVE_DOWN"), "down.png"),
					mkLink("index.php/admin/forums/forum/create?category=".$row["ID"], _l("L_ADD_FORUM"), "forum.png"),
					mkLink("index.php/admin/forums/category/edit?id=".$row["ID"], _l("L_EDIT"), "edit.png"),
					mkLink("modules/forums/main.act.php?action=delete_category&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), "delete.png", true)
				);
				if (!$row["Status"]) $row["Actions"][] = mkLink("modules/forums/main.act.php?action=enable_category&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_ENABLE"));
				$row["Actions"] = mkButtonDisplay($row["Actions"]);

				$tpl->set_arr($row, "CATEGORY");

				$tpl->savebuff("CATEGORY");

			}

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE" => _l("L_FORUMS"),
					"BLOCK_SUBTITLE" => _l("L_CREATE_CATEGORY"),
					"BLOCK_ICON" => mkIcon("categories.png", 16),
					"ICONCHOOSER" => mkIconChooser(16, "category.png"),
					"STATUS.SEL" => booleanStatus(1, "status"),
					"ORDERID.SEL" => mkSelect($category_order, "0", "orderid"),
					"CATEGORY" =>"",
					"NAME" => "",
					"DESCRIPTION" => "",
					"AUTH_ACCESS" => mkAuthSelect(conf::getKey("forums", "default_auth_access", "*", "s"), "auth_access"),
					"AUTH_POST" => mkAuthSelect(conf::getKey("forums", "default_auth_post", "$", "s"), "auth_post"),
					"ACTION" => "new_category",
					"RETURN" => "",
					"CATEGORIES" => $categories
				)
			);

			$mcBuff = $tpl->make(null, false, array("CATEGORY.FORUM"));
		break;
	}


?>