<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/forums/main.lib.php";

	$action = _ext("action", 1);

	$allowed_categories = forum_getAllowedCategories();

	$page = _ext("page");

	switch ($action) {
		default:

			$catid = intval(_ext("cat", 1));
			$frmid = intval(_ext("frm", 2));
			$tpcid = intval(_ext("tpc", 3));
			$msgid = intval(_ext("msg", 4));

			if ($catid && $frmid) {

				forum_updateForumInfo($frmid);

				$frm_auth = forum_checkAuth($catid, $frmid);

				$gen_info = Array();

				/* checking user acces for the requested forums category */
				if (in_array($catid, $allowed_categories)) {

					/* setting $category_title && $category_icon */
					$db->query("SELECT Name, Icon FROM ".db_table("forum_category")."
					WHERE ID = '{$catid}'", __FILE__, __LINE__);

					$row = $db->fetch_row();
					saneHTML($row);

					$gen_info["CAT_LINK"] = mkLink("index.php/forums/{$catid}", $gen_info["CAT_TITLE"] = $row["Name"]);
					$gen_info["CAT_ICON"] = mkIcon($row["Icon"], 16);
					//

					/* setting $forum_title && $forum_icon */
					$db->query("SELECT Name, Icon FROM ".db_table("forum_forum")."
					WHERE ID = '{$frmid}'", __FILE__, __LINE__);

					$row = $db->fetch_row();
					saneHTML($row);

					$gen_info["FRM_LINK"] = mkLink("index.php/forums/{$catid}/{$frmid}", $gen_info["FRM_TITLE"] = $row["Name"]);
					$gen_info["FRM_ICON"] = mkIcon($row["Icon"], 16);
					//

					if ($tpcid) {

						$frm_auth = forum_checkAuth($catid, $frmid, $tpcid);

						/* setting $thread_title && $thread_icon */
						$db->query("SELECT Title, Icon
						FROM ".db_table("forum_message")."
						WHERE is_Topic = '1' AND TopicID = '{$tpcid}'",
						__FILE__, __LINE__);

						$row = $db->fetch_row();
						saneHTML($row);

						$gen_info["TPC_LINK"] = mkLink("index.php/forums/{$catid}/{$frmid}/{$tpcid}", $gen_info["TPC_TITLE"] = $row["Title"]);
						$gen_info["TPC_ICON"] = mkIcon($row["Icon"], 16);

						if ($msgid) {
							if (_ext("edit")) {
								/*
								*  Edit Message
								*/

								$db->query("SELECT ID, TopicID,
								Icon, Title, Content, Nickname, ContactMail

								FROM ".db_table("forum_message")."
								WHERE ID = '{$msgid}' AND TopicID = '{$tpcid}'
								", __FILE__, __LINE__);

								$row = $db->fetch_row();
								saneHTML($row);

								$tpl = new ContentBlock();
								$tpl->insert("BLOCK_CONTENT", "forums/post.form.tpl");

								$rtb = new rtbEditor($row["Content"]);
								$rtb->setSize(350, 150);

								$tpl->set_arr($row);

								$tpl->set_arr (
									Array (
										"BLOCK_TITLE" => _l("L_EDIT_MESSAGE"),
										"BLOCK_ICON" => mkIcon("forums.png", 16),
										"CATEGORY" => $catid,
										"FORUM" => $frmid,
										"THREAD" => $tpcid,
										"RTBEDITOR" => $rtb->make(),
										"ICONCHOOSER" => mkIconChooser(16, "topic.png"),
										"ACTION" => "edit_message",
										"RETURN" => local_referer()."#{$msgid}",
										"AUTH" => gauth("$")
									)
								);

								$mcBuff = $tpl->make();
							} else {
								$mcBuff = accessDenied();

							}
						} else {

							if (_ext("reply") && $frm_auth["reply"]) {
								/*
								*  Thread Reply
								*/

								/* getting topic title */
								$db->query("SELECT Title
								FROM ".db_table("forum_message")."
								WHERE TopicID = '{$tpcid}'
								ORDER BY CreationTime ASC LIMIT 1", __FILE__, __LINE__);

								$row = $db->fetch_row();
								saneHTML($row);

								$tpl = new ContentBlock();
								$tpl->insert("BLOCK_CONTENT", "forums/post.form.tpl");

								$rtb = new rtbEditor();
								$rtb->setSize(350, 150);

								$tpl->set_arr (
									Array (
										"BLOCK_TITLE" => _l("L_REPLY"),
										"BLOCK_ICON" => mkIcon("forums.png", 16),
										"CATEGORY" => $catid,
										"FORUM" => $frmid,
										"THREAD" => $tpcid,
										"ID" => 0,
										"NICKNAME" => "",
										"CONTACTMAIL" => "",
										"TITLE" => "RE: {$row["Title"]}",
										"RTBEDITOR" => $rtb->make(),
										"ICONCHOOSER" => mkIconChooser(16, "topic.png"),
										"RETURN" => "../../index.php/forums/{$catid}/{$frmid}/{$tpcid}",
										"ACTION" => "reply_topic",
										"AUTH" => gauth("$")
									)
								);

								$mcBuff = $tpl->make();

								/* messages summary */
								$tpl = new ContentBlock();
								$tpl->insert("BLOCK_CONTENT", "forums/summary.tpl");

								$db->query("SELECT Icon, Title, Content, CreationTime,
								UserID, Nickname, ContactMail
								FROM ".db_table("forum_message")."
								WHERE TopicID = '{$tpcid}'
								ORDER BY CreationTime ASC", __FILE__, __LINE__);

								$sw = 0;
								while ($row = $db->fetch_row()) {
									saneHTML($row, "Content");
									Format::Style($row["Content"], $row["UserID"]);

									$row["SW_CLASS"] = sw_class($sw);
									$row["Icon"] = mkIcon($row["Icon"], 16);
									$row["CreationTime"] = dateFormat($row["CreationTime"]);
									$row["Author"] = mkForumUserLink($row["UserID"], $row["Nickname"], $row["ContactMail"]);

									$tpl->set_arr($row, "MESSAGE");
									$tpl->savebuff("MESSAGE");
								}

								$tpl->set_arr (
									Array (
										"BLOCK_TITLE" => _l("L_SUMMARY"),
										"BLOCK_ICON" => mkIcon("forums.png", 16)
									)
								);

								$mcBuff .= $tpl->make();

							} else {

								/*
								*	Forum Thread
								*/
								$tpl = new ContentBlock();
								$tpl->insert("BLOCK_CONTENT", "forums/thread.tpl");

								/* pager */
								$pager = $GLOBALS["db"]->pager(
									"SELECT ID FROM ".db_table("forum_message")." WHERE
									TopicID = '{$tpcid}'",
									"index.php/forums/{$catid}/{$frmid}/{$tpcid}/?page=%p", $page, conf::getKey("forums", "messages_per_page")
								);

								$db->query("SELECT
								ID, Icon, Title, Content, CreationTime, Nickname, ContactMail, UserID
								FROM ".db_table("forum_message")."
								WHERE TopicID = '{$tpcid}'
								ORDER BY CreationTime ASC {$pager["sql"]}", __FILE__, __LINE__);

								if ($db->num_rows()) {

									// updating statistics
									$db->query("UPDATE ".db_table("forum_thread")." SET
									stat_Reads = stat_Reads + 1
									WHERE ID = '{$tpcid}'", __FILE__, __LINE__, true);

									$sw = 0;
									while ($row = $db->fetch_row()) {
										saneHTML($row, "Content");

										Format::Style($row["Content"], $row["UserID"]);

										$row["Avatar"] = mkUserAvatar($row["UserID"]);
										$row["Icon"] = mkIcon($row["Icon"], 16);
										$row["CreationTime"] = dateFormat($row["CreationTime"]);
										$row["Author"] = mkForumUserLink($row["UserID"], $row["Nickname"], $row["ContactMail"]);

										$row["Actions"] = "";

										if (forumMessage_authEdit($row["ID"], $row["CreationTime"], $row["UserID"])) {
											$row["Actions"] = Array();

											$row["Actions"][] = mkLink("index.php/forums/{$catid}/{$frmid}/{$tpcid}/{$row["ID"]}?edit=1", _l("L_EDIT"));
											$row["Actions"][] = mkLink("modules/forums/main.act.php?action=delete_message&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1);

											$row["Actions"] = mkButtonDisplay($row["Actions"]);
										}

										$row["SW_CLASS"] = sw_class($sw);

										$tpl->set_arr($row, "MESSAGE");
										$tpl->savebuff("MESSAGE");
									}

									$act = Array();

									$db->query("SELECT mode_Locked, mode_Sticked
										FROM ".db_table("forum_thread")."
										WHERE ID = '{$tpcid}'", __FILE__ , __LINE__);
									$row = $db->fetch_row();
									saneHTML($row);

									if ($frm_auth["reply"]) $act[] = mkLink("index.php/forums/{$catid}/{$frmid}/{$tpcid}?reply=1", _l("L_REPLY"), "reply.png");

									if (gauth("admin")) {
										// is locked?
										$act[] = mkLink("modules/forums/main.act.php?action=thread_mode&mode=".($row["mode_Locked"] ? "un": "")."lock&id={$tpcid}&auth="._l("C_AUTH_STR")."", _l("L_".($row["mode_Locked"] ? "UN" :"")."LOCK_THREAD"), ($row["mode_Locked"] ? "unlock" : "locked").".png");
										// is sticked?
										$act[] = mkLink("modules/forums/main.act.php?action=thread_mode&mode=".($row["mode_Sticked"] ? "un": "")."stick&id={$tpcid}&auth="._l("C_AUTH_STR")."", _l("L_".($row["mode_Sticked"] ? "UN" :"")."STICK_THREAD"), ($row["mode_Sticked"] ? "open" :"sticked").".png");
										// delete
										$act[] = mkLink("modules/forums/main.act.php?action=delete_thread&id={$tpcid}&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), "delete.png", true);

										$tpl->set("CATEGORIES.SEL", mkSelect(forum_getForums(), $frmid, "category", "onchange=\"confirmAction('"._l("C_SITE.REL_URL")."modules/forums/main.act.php?action=thread_move&id={$tpcid}&to='+this.value+'&auth="._l("C_AUTH_STR")."', '"._l("L_MOVE_TOPIC")."')\""));
									}


									$tpl->set_arr(
										Array (
											"BLOCK_TITLE" => _l("L_VIEW_TOPIC"),
											"BLOCK_SUBTITLE" => $gen_info["TPC_TITLE"],
											"BLOCK_ICON" => $gen_info["TPC_ICON"],
											"ACTIONS" => count($act) ? mkButtonDisplay($act) : "",
											"PAGER" => $pager["html"]
										)
									);

									$tpl->set_arr($gen_info);

									$mcBuff = $tpl->make();

								} else {
									$mcBuff = accessDenied();
								}
							}
						}
					} else {
						$req = _ext("req", 4);

						switch ($req) {
							case "new_topic":
								if ($frm_auth["post"]) {

									$tpl = new ContentBlock();
									$tpl->insert("BLOCK_CONTENT", "forums/post.form.tpl");

									$rtb = new rtbEditor();
									$rtb->setSize(350, 150);

									$tpl->set_arr (
										Array (
											"BLOCK_TITLE" => _l("L_NEW_TOPIC"),
											"BLOCK_ICON" => mkIcon("forums.png", 16),
											"CATEGORY" => $catid,
											"FORUM" => $frmid,
											"THREAD" => 0,
											"ID" => 0,
											"NICKNAME" => "",
											"CONTACTMAIL" => "",
											"TITLE" => "",
											"RTBEDITOR" => $rtb->make(),
											"ICONCHOOSER" => mkIconChooser(16, "topic.png"),
											"RETURN" => "",
											"ACTION" => "new_topic",
											"AUTH" => gauth("$")
										)
									);

									$mcBuff = $tpl->make();
								} else {
									$mcBuff = accessDenied();
								}
							break;
							default:
								/* Index of topics (forum threads) */

								$tpl = new ContentBlock();
								$tpl->insert("BLOCK_CONTENT", "forums/thread-index.tpl");

								/* pager */
								$pager = $GLOBALS["db"]->pager(
									"SELECT ID FROM ".db_table("forum_thread")." WHERE
									ForumID = '{$frmid}'",
									"index.php/forums/{$catid}/{$frmid}?page=%p", $page, conf::getKey("forums", "threads_per_page")
								);

								$db->query("SELECT
								t.ID, t.stat_Reads, t.stat_Replies, t.mode_Sticked, t.mode_Locked, m.Icon,
								m.Title, m.CreationTime,
								m.Nickname, m.UserID
								FROM ".db_table("forum_thread")." t, ".db_table("forum_message")." m
								WHERE t.ForumID = '{$frmid}' AND m.TopicID=t.ID AND m.is_Topic = '1'
								ORDER BY t.mode_Sticked DESC, m.CreationTime DESC
								{$pager["sql"]}",
								__FILE__, __LINE__);

								$topics = $db->num_rows();
								$sw = 0;
								while ($row = $db->fetch_row()) {
									saneHTML($row);

									/* last message */
									$q = $db->query("SELECT Title, Nickname, ContactMail, UserID,
									CreationTime
									FROM ".db_table("forum_message")."
									WHERE TopicID = '{$row["ID"]}'
									ORDER BY CreationTime DESC LIMIT 1",
									__FILE__, __LINE__, true);

									$row2 = $db->fetch_row($q);
									saneHTML($row2);
									$row["LAST_TOPIC"] = $row2["Title"];
									$row["LAST_AUTHOR"] = mkForumUserLink($row2["UserID"], $row2["Nickname"], $row2["ContactMail"]);
									$row["LAST_DATE"] = dateFormat($row2["CreationTime"]);

									$row["Icon"] = mkIcon($row["Icon"], 16);
									$row["Title"] = mkLink("index.php/forums/{$catid}/{$frmid}/{$row["ID"]}", $row["Title"]);

									$row["SW_CLASS"] = sw_class($sw);
									$row["STATUS_ICON"] = forum_mkStatusIcon($row["mode_Sticked"], $row["mode_Locked"]);

									$tpl->set_arr($row, "TOPIC");
									$tpl->savebuff("TOPIC");
								}

								$act = Array();
								if ($frm_auth["post"]) {
									$act[] = mkLink("index.php/forums/{$catid}/{$frmid}/0/new_topic", _l("L_NEW_TOPIC"), "new.png");
								}

								$tpl->set_arr (
									Array (
										"BLOCK_TITLE" => _l("L_VIEW_FORUM"),
										"BLOCK_SUBTITLE" => $gen_info["FRM_TITLE"],
										"BLOCK_ICON" => $gen_info["FRM_ICON"],
										"TOPICS" => $topics,
										"ACTIONS" => count($act) ? mkButtonDisplay($act) : "",
										"PAGER" => $pager["html"]
									)
								);

								$tpl->set_arr($gen_info);

								$mcBuff = $tpl->make();
							break;
						}

					}

				} else {
					$mcBuff = accessDenied();
				}

			} else {

				/*
					Categories index
					Here we are showing a list of all categories that this user
					is allowed to see.
				*/

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "forums/index.tpl");

				$db->query("SELECT ID, Icon, Name, Description
				FROM ".db_table("forum_category")."
				WHERE (".forum_getAllowedCategories(true, "ID").") ".($catid ? "AND ID = '{$catid}'" : "")."
				ORDER BY OrderID ASC",
				__FILE__, __LINE__);

				$sw = 0;
				if (($categories = $db->num_rows()) > 0) {

					while ($row = $db->fetch_row()) {
						saneHTML($row);

						// forums for this category
						$q = $db->query("SELECT ID, Icon, Name, Description,
						MessageCount, TopicCount, LastPostID
						FROM ".db_table("forum_forum")."
						WHERE CategoryID = '{$row["ID"]}' AND Status = '1'
						ORDER BY OrderID ASC",
						__FILE__, __LINE__, true);

						$tpl->reset("CATEGORY.FORUM");

						if ($db->num_rows($q)) {

							while ($row2 = $db->fetch_row($q)) {
								saneHTML($row2);
								$tpl->reset("CATEGORY.FORUM", true);

								$row2["Icon"] = mkIcon($row2["Icon"], 16);
								$row2["Name"] = mkLink("index.php/forums/{$row["ID"]}/{$row2["ID"]}", $row2["Name"]);

								/* Last message */
								$r = $db->query("SELECT ID, TopicID, Title, CreationTime,
								UserID, Nickname, ContactMail
								FROM ".db_table("forum_message")."
								WHERE ID = '{$row2["LastPostID"]}'", __FILE__, __LINE__, true);

								if ($db->num_rows($r)) {
									// there are messages
									$row3 = $db->fetch_row($r);
									saneHTML($row3);
									$row2["LAST_TOPIC"] = mkLink("index.php/forums/{$row["ID"]}/{$row2["ID"]}/{$row3["TopicID"]}?page=last#{$row3["ID"]}", $row3["Title"]);
									$row2["LAST_AUTHOR"] = mkForumUserLink($row3["UserID"], $row3["Nickname"], $row3["ContactMail"]);
									$row2["LAST_DATE"] = dateFormat($row3["CreationTime"]);
									$row2["LAST_MESSAGE"] = sprintf(_l("L_LAST_MESSAGE_FORMAT"), $row2["LAST_TOPIC"], $row2["LAST_AUTHOR"], $row2["LAST_DATE"]);
								} else {
									// there are no messages
									$row2["LAST_MESSAGE"] = "("._l("L_EMPTY_FORUM").")";
								}
								$row2["SW_CLASS"] = sw_class($sw);
								$row2["STATUS_ICON"] = mkIcon("open.png", 16);

								$tpl->set_arr($row2, "CATEGORY.FORUM");

								$tpl->savebuff("CATEGORY.FORUM");
							}
						} else {
							$tpl->hideBlock("CATEGORY.FORUM");
						}

						$row["Icon"] = mkIcon($row["Icon"], 16);

						$tpl->set_arr($row, "CATEGORY");

						$tpl->savebuff("CATEGORY");
					}

					$tpl->set_arr (
						Array (
							"BLOCK_TITLE" => _l("L_FORUMS"),
							"BLOCK_SUBTITLE" => _l("L_CATEGORIES_INDEX"),
							"BLOCK_ICON" => mkIcon("forums.png", 16),
							"CATEGORIES" => $categories
						)
					);

					$mcBuff = $tpl->make();
				}
			}

		break;
	}


	// saving buffer into modCore
	$mc->save($mcBuff);
?>