<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	function forumMessage_authEdit($id, $creation, $authorid) {
		return (gauth("forums") || (gauth("$") && ($authorid == $GLOBALS["User"]["ID"]) && ($creation+conf::getKey("forums", "edit_time")) >= time()));
	}

	function mkForumUserLink($uid, $nickname = null, $url = null) {
		return ($author = getUserByID($uid)) ? $author : "&lt;".safeLink($url, $nickname ? $nickname : _l("L_ANONYMOUS"))."&gt;";
	}

	function forum_deleteThread($id) {
		$GLOBALS["db"]->query("DELETE FROM ".db_table("forum_thread")." WHERE ID = '{$id}'", __FILE__, __LINE__, true);
		$GLOBALS["db"]->query("DELETE FROM ".db_table("forum_message")." WHERE TopicID = '{$id}'", __FILE__, __LINE__, true);
		slog("forums: deleted forum thread '$id'", "actions", 1);
	}

	function forum_deleteForum($id) {
		$GLOBALS["db"]->query("DELETE FROM ".db_table("forum_forum")." WHERE ID = '{$id}'", __FILE__, __LINE__, true);
		$q = $GLOBALS["db"]->query("SELECT ID FROM ".db_table("forum_thread")."
		WHERE ForumID = '{$id}'", __FILE__, __LINE__, true);
		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			forum_deleteThread($row["ID"]);
		}
		slog("forums: deleted forum '$id'", "actions", 1);
	}

	function forum_deleteCategory($id) {
		$GLOBALS["db"]->query("DELETE FROM ".db_table("forum_category")." WHERE ID = '{$id}'", __FILE__, __LINE__, true);
		$q = $GLOBALS["db"]->query("SELECT ID FROM ".db_table("forum_forum")."
		WHERE CategoryID = '{$id}'", __FILE__, __LINE__, true);
		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			forum_deleteForum($row["ID"]);
		}
		slog("forums: deleted category '$id'", "actions", 1);
	}

	function forum_mkStatusIcon($sticked = false, $locked = false) {
		if ($sticked && $locked) {
			$icon = "sticked-locked";
		} elseif ($sticked) {
			$icon = "sticked";
		} elseif ($locked) {
			$icon = "locked";
		} else {
			$icon = "open";
		}
		return mkIcon("$icon.png", 16);
	}

	function forum_updateForumInfo($forum) {
		$q = $GLOBALS["db"]->query("SELECT ID, stat_Replies FROM ".db_table("forum_thread")."
		WHERE ForumID = '{$forum}'", __FILE__, __LINE__, true);

		$topics = $messages = $last_message = 0;

		$topics = $GLOBALS["db"]->num_rows($q);

		if ($topics) {
			while ($row = $GLOBALS["db"]->fetch_row($q)) {
				$messages += $row["stat_Replies"] + 1;
			}

			$q = $GLOBALS["db"]->query("SELECT m.ID FROM ".db_table("forum_message")." m,
			".db_table("forum_thread")." t
			WHERE t.ForumID = '{$forum}' AND m.TopicID = t.ID
			ORDER BY m.CreationTime DESC LIMIT 1
			", __FILE__, __LINE__, true);

			$row = $GLOBALS["db"]->fetch_row($q);
			$last_message = $row["ID"];
		}

		$q = $GLOBALS["db"]->query("
			UPDATE ".db_table("forum_forum")." SET
				MessageCount = '$messages',
				TopicCount = '$topics',
				LastPostID = '$last_message'
			WHERE ID = '{$forum}'
		", __FILE__, __LINE__, true);

	}

	function forum_updateThreadInfo($thread, $read = false) {
		// replies
		$q = $GLOBALS["db"]->query("SELECT ID FROM ".db_table("forum_message")."
		WHERE TopicID = '{$thread}' AND is_Topic = '0'", __FILE__, __LINE__, true);

		$replies = intval($GLOBALS["db"]->num_rows($q));

		$GLOBALS["db"]->query("UPDATE ".db_table("forum_thread")." SET
		stat_Replies = '{$replies}' ".($read ? ", stat_Reads = stat_Reads+1": "")."
		WHERE ID = '{$thread}'", __FILE__, __LINE__);
	}

	function forum_checkAuth($catid, $frmid = 0, $trdid = 0) {
		$auth = Array();

		if (gauth("forums")) {

			$auth["view"] = $auth["post"] = $auth["reply"] = true;

		} else {

			$allowed = forum_getAllowedCategories();

			if ($frmid) {
				/* checking existence */
				$q = $GLOBALS["db"]->query("SELECT ID
				FROM ".db_table("forum_forum")." WHERE ID = '{$frmid}'", __FILE__, __LINE__, true);
				if (!$GLOBALS["db"]->num_rows()) {
					$auth["view"] = $auth["post"] = $auth["reply"] = false;
				}
			}

			if ($trdid) {
				/* checking existence, cannot be locked */
				$q = $GLOBALS["db"]->query("SELECT ID, mode_Locked
				FROM ".db_table("forum_thread")." WHERE ID = '{$trdid}'", __FILE__, __LINE__, true);
				if ($GLOBALS["db"]->num_rows($q)) {
					$row = $GLOBALS["db"]->fetch_row($q);
					if (!$row["mode_Locked"]) {
						$auth["post"] = $auth["reply"] = true;
					}
				}
			}

			/* category authorization */
			$q = $GLOBALS["db"]->query("SELECT auth_Access, auth_Post FROM
			".db_table("forum_category")." WHERE ID = '{$catid}'", __FILE__, __LINE__, true);

			if ($GLOBALS["db"]->num_rows($q)) {
				$row = $GLOBALS["db"]->fetch_row($q);
				$auth["view"]  = gauth($row["auth_Access"]);
				$auth["post"]  = gauth($row["auth_Post"]);
			}

			if (!isset($auth["view"])) $auth["view"] = false;
			if (!isset($auth["post"])) $auth["post"] = false;
			if (!isset($auth["reply"])) $auth["reply"] = false;

		}

		return $auth;

	}

	function forum_getForums() {
		$q = $GLOBALS["db"]->query("SELECT ID, Name
		FROM ".db_table("forum_forum")."
		ORDER BY CategoryID DESC
		", __FILE__, __LINE__, true);
		$forums = Array();
		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			$forums[$row["ID"]] = $row["Name"];
		}
		return $forums;
	}

	/* getting allowed categories */
	function forum_getAllowedCategories($mklock = false, $lockfield = "CategoryID", $auth = null) {
		$cache = "forum_getAllowedCategories()";
		if (!Cache::Get($cache)) {
			$allowed = Array();
			$q = $GLOBALS["db"]->query("SELECT ID, auth_Access FROM ".db_table("forum_category")." WHERE Status = '1'", __FILE__, __LINE__, true);
			while ($row = $GLOBALS["db"]->fetch_row($q)) {
				if (gauth($row["auth_Access"], $auth)) {
					$allowed[] = $row["ID"];
				}
			}
			Cache::Set($cache, $allowed);
		}
		$return = Cache::Get($cache);
		if ($mklock) $return = "$lockfield = '".implode($return, "' OR $lockfield = '")."'";
		return $return;
	}
?>