<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class GekkoModule_Forums {
		function create_menu() {
			return false;
		}
		function configure() {
			Conf::getKey("forums", "edit_time", 600, "i");
			Conf::getKey("forums", "threads_per_page", 20, "i");
			Conf::getKey("forums", "messages_per_page", 30, "i");
		}
		function install() {
			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("forum_category")." (
				ID TINYINT (3) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				OrderID SMALLINT,
				Icon VARCHAR (255) NOT NULL default 'category.png',

				Name VARCHAR (255),
				Description TEXT,
				Status ENUM('0','1') NOT NULL default '1',

				auth_Access VARCHAR (255) NOT NULL default '*',
				auth_Post VARCHAR (255) NOT NULL default '$'
			)
			", __FILE__, __LINE__, true);

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("forum_forum")." (
				ID SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				CategoryID TINYINT (3) UNSIGNED NOT NULL,

				OrderID SMALLINT,
				Icon VARCHAR (255) NOT NULL default 'forum.png',

				Name VARCHAR (255),
				Description TEXT,

				MessageCount INT (11) UNSIGNED NOT NULL,
				TopicCount INT (11) UNSIGNED NOT NULL,
				LastPostID INT (10) UNSIGNED NOT NULL,

				Status ENUM('0','1') NOT NULL default '1'
			)
			", __FILE__, __LINE__, true);

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("forum_thread")." (
				ID MEDIUMINT (8) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				ForumID SMALLINT (5) UNSIGNED NOT NULL,
				stat_Reads SMALLINT (5) UNSIGNED NOT NULL,
				stat_Replies SMALLINT (5) UNSIGNED NOT NULL,
				mode_Locked  ENUM('0','1') NOT NULL default '0',
				mode_Sticked  ENUM('0','1') NOT NULL default '0'
			)
			", __FILE__, __LINE__, true);

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("forum_message")." (
				ID INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),

				TopicID MEDIUMINT (8) UNSIGNED NOT NULL,

				Icon VARCHAR (255) NOT NULL default 'message.png',
				Title VARCHAR (255),
				Content TEXT,

				is_Topic ENUM('0','1') NOT NULL default '0',

				CreationTime INT (11) UNSIGNED NOT NULL,
				Nickname VARCHAR (32),
				ContactMail VARCHAR (64),
				UserID MEDIUMINT (8) UNSIGNED NOT NULL
			)
			", __FILE__, __LINE__, true);

			modCore::registerModule($GLOBALS["cgdb"]["forums"], "forums", "*", $GLOBALS["cgdb"]["forums"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("forum_category"), __FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("forum_forum"), __FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("forum_thread"), __FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("forum_message"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			if (check_version("0.5.10", $provided_v) < 0) {
				$GLOBALS["db"]->query("ALTER TABLE ".db_table("forum_category")."
				CHANGE COLUMN Status Status ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);

				$GLOBALS["db"]->query("ALTER TABLE ".db_table("forum_forum")."
				CHANGE COLUMN Status Status ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);

				$GLOBALS["db"]->query("ALTER TABLE ".db_table("forum_thread")."
				CHANGE COLUMN mode_Locked mode_Locked ENUM('0','1') NOT NULL default '0',
				CHANGE COLUMN mode_Sticked mode_Sticked ENUM('0','1') NOT NULL default '0'",
				__FILE__, __LINE__);

				$GLOBALS["db"]->query("ALTER TABLE ".db_table("forum_message")."
				CHANGE COLUMN is_Topic is_Topic ENUM('0','1') NOT NULL default '0'",
				__FILE__, __LINE__);
			}
		}
		function ext_uninstall($module) {

		}
	}

?>