<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-BLOCK")) die();

	/*
	<%%>
	<?xml version="1.0" encoding="UTF-8"?>
	<blockscript>
		<info lang="en">
			<title>Archive</title>
			<description>News archive by month in the last year</description>
			<author><![CDATA[xiam &lt;<a href="mailto:xiam@users.sourceforge.net">xiam@users.sourceforge.net</a>&gt;]]></author>
			<homepage><![CDATA[<a href="http://www.gekkoware.org">http://www.gekkoware.org</a>]]></homepage>
		</info>
		<info lang="es">
			<title>Archivo</title>
			<description><![CDATA[Archivo de noticias por mes en el &uacute;ltimo a&ntilde;o]]></description>
		</info>
	</blockscript>
	<%%>
	*/

	/* lower and upper timestamp limits for this month */
	$lower_ts = mktime(0, 0, 0, date("n"), date("j"), date("Y")-1);

	/* events counter */
	$events = Array();

	require_once GEKKO_ROOT."modules/categories/main.lib.php";

	$cat_lock = getAllowedCategories(true);

	$q = $GLOBALS["db"]->query("SELECT ID, Title, CreationTime
	FROM ".db_table("news")." WHERE Status = '1' AND CreationTime >= '{$lower_ts}'
	ORDER BY CreationTime DESC",
	__FILE__, __LINE__);

	while ($row = $GLOBALS["db"]->fetch_row($q)) {
		saneHTML($row);
		$month = date("Y.n", $row["CreationTime"]);

		$events[$month] = isset($events[$month]) ? $events[$month]+1 : 1;

	}
	$last_year = false;
	foreach ($events as $month => $counter) {
		list($year, $month) = explode(".", $month);

		if ($last_year != $year) {
			$return .= "<h4>$year</h4>\n";
			$last_year = $year;
		}

		$return .= "<a href=\""._l("C_SITE.REL_URL")."index.php/news/?date=$year.$month\">".htmlentities(ucwords(strftime("%B %Y ($counter)", mktime(0,0,0,$month,1,$year))))."</a><br />\n";
	}


?>