<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";
	require_once GEKKO_ROOT."lib/core.lib.php";
	require_once GEKKO_ROOT."lib/format.lib.php";
	require_once GEKKO_ROOT."modules/news/main.lib.php";

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	gpGet("action", 1);
	gpGet("id", 1);
	gpGet("return", 1);

	switch ($action) {
		case "delete":
			if (!is_admin()) abort(accessDenied());

			requireVars($id);

			execWithEach($id, "deleteNewsEntry");
		break;
		case "publish":
			if (!is_admin()) abort(accessDenied());

			requireVars($id);

			$db->query("SELECT Status FROM ".db_table("news")."
			WHERE ID = '{$id}' AND Status = '0' OR Status = '2' ", __FILE__, __LINE__);
			/*
				if this entry was a draft or it was submitted by an user
				then we need to update timestamp too
			*/
			$upd_time = ($db->num_rows());

			$db->query("UPDATE ".db_table("news")." SET
			Status = '1' ".($upd_time ? ", CreationTime = '".time()."'" : "")."
			WHERE ID = '{$id}'", __FILE__, __LINE__);

		break;
		case "create":

			if (is_admin() || gauth(conf::getkey("news", "auth_submit"))) {

				gpGlobalize("icon, status, category, title, introduction,
				content, allowcomments, source");

				if (!is_admin()) {
					$antiflood = $AccessTable->set_generic_rule("news-submission", "post");
					$AccessTable->load_rule($antiflood, "E_ANTI_FLOOD");
				}

				requireVars($category, $title, $content);

				rtb_codefix($content);
				rtb_codefix($introduction);

				if (!$introduction)
					$introduction = mkIntro($content);

				// inserting into database
				$db->query ("
				INSERT INTO ".db_table("news")."
					(
						ID,
						UserID,
						Category,
						Icon,
						Title,
						Introduction,
						Content,
						CreationTime,
						pageReads,
						Source,
						Status,
						AllowComments
					)
						VALUES
					(
						'".$db->free_id("news")."',
						'{$User["ID"]}',
						'{$category}',
						'{$icon}',
						'{$title}',
						'{$introduction}',
						'{$content}',
						'".time()."',
						'0',
						'{$source}',
						'".(is_admin() ? $status : 2)."',
						'{$allowcomments}'
					)
				", __FILE__, __LINE__);

				slog(is_admin() ? "news: posted '$title'" : "news: submitted '$title' to revision", "actions", 1);

				if (!is_admin())
					$return = "../../index.php/news?message=".urlencode(_l("L_SUBMISSION_THANKS"))."&type=success";

			} else {
				abort(accessDenied());
			}
		break;
		case "edit":

			if (is_admin()) {

				gpGlobalize("id, icon, status, category, title, introduction, content,
				allowcomments, source");

				requireVars($id, $category, $title, $content);

				rtb_codefix($content);
				rtb_codefix($introduction);

				if (!$introduction) $introduction = mkIntro($content);

				/* checking if this text was a draft */
				$ptime = false;
				$db->query("SELECT Status FROM ".db_table("news")." WHERE ID = '$id'");
				$row = $db->fetch_row();
				if (!$row["Status"]) $ptime = true;

				$db->query("
					UPDATE ".db_table("news")." SET
						Category = '{$category}',
						Icon = '{$icon}',
						Title = '{$title}',
						Introduction = '{$introduction}',
						Content = '{$content}',
						Status = '{$status}',
						".($ptime ? "CreationTime = '".time()."',": "")."
						AllowComments = '{$allowcomments}'
					WHERE ID = '{$id}'
				", __FILE__, __LINE__);

				slog("news: entry '$id' was updated", "actions", 1);
			} else {
				abort(accessDenied());
			}

		break;
		default:
			abort(_l("L_UNDEFINED_ACTION"));
		break;
	}

	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>