<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/categories/main.lib.php";
	require_once GEKKO_ROOT."modules/comments/main.lib.php";
	require_once GEKKO_ROOT."modules/users/main.lib.php";
	require_once GEKKO_ROOT."modules/news/main.lib.php";
	require_once GEKKO_ROOT."lib/feeder.lib.php";

	$action = _ext("action", 1);
	$page = _ext("page", 1);
	$id = _ext("id", 2);
	$category = _ext("category");

	switch ($action) {
		case "submit":
			if (gauth(conf::getKey("news", "auth_submit"))) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "news/news.form.tpl");

				$rtb_c = new rtbEditor("");
				$rtb_c->setSize(350, 300);

				$rtb_i = new rtbEditor("", "introduction");
				$rtb_i->setSize(350, 150);

				$tpl->set_arr (
					Array (
						"BLOCK_TITLE" => _l("L_NEWS"),
						"BLOCK_SUBTITLE" => _l("L_COMPOSE"),
						"BLOCK_ICON" => mkIcon("news.png", 16),
						"ICONCHOOSER" => mkIconChooser(16, "news.png"),
						"OPTIONS" =>  mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), 1),
						"ACTION" => "create",
						"STATUS.SEL" => mkSelect(getNewsStatus(), 2, "status", "disabled=\"disabled\""),
						"CATEGORIES.SEL" => mkSelect(getCategories(true), null, "category"),
						"TITLE" => "",
						"INTRODUCTION" => "",
						"CONTENT" => "",
						"SOURCE" => "",
						"TITLE" => "",
						"RETURN" => "",
						"RTBEDITOR.INTRO" => $rtb_i->make(),
						"RTBEDITOR.CONTENT" => $rtb_c->make()
					)
				);

				$mcBuff = $tpl->make();
			} else {
				$mcBuff = accessDenied();
			}
		break;
		case "feed": {

			_l("C_SITE.REL_URL", "");

			$type = _ext("type", 2);

			if (($d = strpos($type, ".")) !== false) $type = substr($type, 0, $d);

			if (($feed = new xml_feed($type)) === false) abort("Unsupported feed type.");

			if ($category) {
				/* category string was provided */
				$access = false;
				$db->query("SELECT ID, auth_Access FROM ".db_table("category")." WHERE Category = '{$category}'", __FILE__, __LINE__);
				if ($db->num_rows()) {
					$row = $db->fetch_row($res);
					$cat_lock = "Category = '{$row["ID"]}'";
					$access = gauth($row["auth_Access"], "*");
				}
				if (!$access) {
					abort("Access denied");
					break;
				}
			} else {
				/* category lock (allowed categories) */
				$cat_lock = getAllowedCategories(true, "Category", "*");
			}

			$db->query ("
			SELECT
					ID, UserID, Title, Introduction, CreationTime
			FROM ".db_table("news")." WHERE Status = '1' AND ($cat_lock)
			ORDER BY CreationTime DESC LIMIT 30
			", __FILE__, __LINE__);

			while ($row = $db->fetch_row()) {
				$feed->create_item();
				// do not save in cache!!
				//Format::Style($row["Content"], $row["UserID"]);
				$feed->set_title($row["Title"]);
				$feed->set_link("index.php/news/view/".urlencode($row["Title"])."?id=".$row["ID"]);
				$feed->set_description($row["Introduction"]);
				$feed->set_date($row["CreationTime"]);
				$feed->set_author($row["UserID"]);
			}

			header("content-type: text/xml; charset=utf-8");
			abort($feed->make());
		}
		case "view": {
			$page = intval(_ext("page"));

			if ((intval($id) < 1) && (intval($id = _ext("id")) < 0)) break;

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "news/read.tpl");

			$tpl->vren("BLOCK_TITLE", "TITLE");
			$tpl->vren("BLOCK_ICON", "ICON");

			$tpl->save();

			$db->query("
				SELECT
				ID, UserID, Category, Icon, Title, Content, CreationTime, Source, pageReads
				FROM ".db_table("news")." WHERE Status = '1' AND ID='{$id}'
			", __FILE__, __LINE__);

			if ($db->num_rows()) {

				$row = $db->fetch_row();

				if (categoryAuth($row["Category"])) {

					saneHTML($row, "Content");

					Format::Style($row["Content"], $row["UserID"]);

					$row["Icon"] = mkIcon($row["Icon"], 16);
					$row["Category_Icon"] = mkIcon(db_get_field("category", $row["Category"], "Icon"), 48);
					$row["Author"] = getUserByID($row["UserID"]);
					$row["CommentsLink"] = mkCommentsLink("news", $row["ID"]);
					$row["Created"] = dateFormat($row["CreationTime"]);
					$row["Avatar"] = mkUserAvatar($row["UserID"]);
					$row["pageReads"] = $row["pageReads"]+1;
					$row["Category_Link"] = mkLink("index.php/news?category=".urlencode($c = getCategoryByID($row["Category"], 16)), $c);

					$tpl->set_arr($row);

					$mcBuff = $tpl->make();

					/* comments */
					$mcBuff .= LoadCommentsBlock (
						"news",
						$row["ID"],
						"index.php/blog/news/".urlencode($row["Title"])."?id=".$row["ID"]."&page=%p",
						$page,
						$row["Title"]
					);

					title_attach($row["Title"], 1);

					/* updating pageReads counter */
					$db->query("UPDATE ".db_table("news")." SET pageReads = pageReads + 1 WHERE ID = '{$id}'", __FILE__, __LINE__);
				} else {
					$mcBuff = accessDenied();
				}
			}
			break;
		}
		default:

			$date = _ext("date");

			$date_lock = (is_array($date = timeMark($date))) ? "CreationTime >= '{$date[0]}' AND CreationTime <= '{$date[1]}'": "1";

			if ($category) {
				/* category string was provided */
				$access = false;
				$db->query("SELECT ID, auth_Access FROM ".db_table("category")." WHERE Category = '{$category}'", __FILE__, __LINE__);
				if ($db->num_rows()) {
					$row = $db->fetch_row();
					$cat_lock = "Category = '{$row["ID"]}'";
					$access = gauth($row["auth_Access"]);
				}
				if (!$access) {
					$mcBuff = accessDenied();
					break;
				}
			} else {
				/* category lock (allowed categories) */
				$cat_lock = getAllowedCategories(true);
			}

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "news/intro.tpl");

			$tpl->vren("BLOCK_TITLE", "TITLE");
			$tpl->vren("BLOCK_ICON", "ICON");

			/* saving a copy of our modified template */
			$tpl->save();

			/* guessing pages */
			$pager = $db->pager (
				"SELECT ID FROM ".db_table("news")." WHERE Status = '1' AND ($date_lock) AND ($cat_lock)",
				"index.php/news?page=%p".($category ? "&category=".urlencode($category)."":"")."", $page, _c("news", "items_per_page")
			);

			$db->query ("
			SELECT
					ID, UserID, Category, Icon, Title, Introduction,
					CreationTime, pageReads
			FROM ".db_table("news")." WHERE Status = '1' AND ($date_lock) AND ($cat_lock)
			ORDER BY CreationTime DESC ".$pager["sql"]."
			", __FILE__, __LINE__);

			while ($row = $db->fetch_row()) {
				saneHTML($row, "Introduction");

				Format::Style($row["Introduction"], $row["UserID"]);

				/* getting saved copy of template */
				$tpl->reset();

				$row["Read"] = mkLink("index.php/news/view/".urlencode($row["Title"])."?id=".$row["ID"]."", _l("L_READ"));
				$row["Icon"] = mkIcon($row["Icon"], 16);
				$row["Author"] = cache_func("getUserByID({$row["UserID"]})");
				$row["CommentsLink"] = mkCommentsLink("news", $row["ID"]);
				$row["Avatar"] = cache_func("mkUserAvatar({$row["UserID"]})");
				$row["Category_Icon"] = mkIcon(db_get_field("category", $row["Category"], "Icon"), 48);
				$row["Created"] = dateFormat($row["CreationTime"]);
				$row["Category_Link"] = mkLink("index.php/news?category=".urlencode($c = getCategoryByID($row["Category"], true)), $c);

				/* passing $row to template variables */
				$tpl->set_arr ($row);

				/* updating buffer */
				$mcBuff .= $tpl->make()."\n";
			}
			/* adding a nice pager at bottom */
			$mcBuff .= $pager["html"];

			/* submit news link */
			$mcBuff .= "<div style=\"text-align: center\"><a href=\""._l("C_SITE.REL_URL")."index.php/news/submit\">[ "._l("L_SUBMIT_NEWS")." ]</a></div>";

			/* feeder buttons */
			htdoc_attach("HEAD", '<link rel="alternate" type="application/rss+xml" title="'._l("C_SITE.TITLE").'" href="'._l("C_SITE.URL").'index.php/news/feed/rss.xml">');
			htdoc_attach("FOOTER", mkFeederButtons("index.php/news/feed/%s"));

		break;

	}

	// saving buffer into modCore
	$mc->save($mcBuff);
?>