<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/categories/main.lib.php";
	require_once GEKKO_ROOT."modules/users/main.lib.php";
	require_once GEKKO_ROOT."modules/pages/main.lib.php";
	require_once GEKKO_ROOT."lib/format.lib.php";

	$action = _ext("action", 2);
	$page = _ext("page", 2);
	$textid = _ext("textid", 3);

	switch ($action) {
		case "edit":
			if ($textid) {
				$categories = getCategories(true);

				$tpl = new ContentBlock();

				$tpl->insert("BLOCK_CONTENT", "pages/index.admin.tpl");
				$tpl->insert("EDITOR.FORM", "pages/editor.form.tpl");

				$db->query("
					SELECT
						ID, Category, TextID, Title, Content, AuthorID, LastEditor, Created, Modified, showTitle, Status
					FROM ".db_table("page")." WHERE TextID = '".$textid."'
				");

				if ($db->num_rows()) {

					$row = $db->fetch_row();
					saneHTML($row);

					$rtb = new rtbEditor($row["Content"]);
					$rtb->setSize(400, 350);

					$row["BLOCK_TITLE"] = _l("L_PAGES");
					$row["BLOCK_ICON"] = mkIcon("pages.png", 16);
					$row["BLOCK_SUBTITLE"] = _l("L_EDIT");
					$row["STATUS.SEL"] = mkSelect(array(_l("L_DRAFT"), _l("L_PUBLISHED")), $row["Status"], "status");
					$row["CATEGORIES.SEL"] = mkSelect($categories, $row["Category"], "category");
					$row["OPTIONS"] = mkCheckBox("showtitle", _l("L_SHOW_TITLE"), $row["showTitle"]);
					$row["ACTION"] = "edit";
					$row["RETURN"] = "../../index.php/admin/pages";
					$row["RTBEDITOR"] = $rtb->make();

					$tpl->set_arr($row);

					$mcBuff = $tpl->make();
				}


			}
		break;
		default:

			$categories = getCategories(true);

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "pages/index.admin.tpl");
			$tpl->insert("EDITOR.FORM", "pages/editor.form.tpl");

			$pager = $db->pager (
				"SELECT ID FROM ".db_table("page")."",
				"index.php/admin/pages/%p", $page, 8
			);

			$db->query ("
				SELECT
					ID, Category, TextID, Title, Content, LastEditor, Modified, Status
				FROM ".db_table("page")."
				ORDER BY Status ASC, Title ASC ".$pager["sql"]."
			", __FILE__, __LINE__);

			$pages = $db->num_rows();

			while ($row = $db->fetch_row()) {

				saneHTML($row, "Content");

				$row["Category"] = getCategoryByID($row["Category"]);
				$row["LastEditor"] = getUserByID($row["LastEditor"]);
				$row["Introduction"] = mkIntro($row["Content"]);
				$row["Modified"] = dateFormat($row["Modified"]);

				$row["TextID"] = urlencode($row["TextID"]);

				$row["Actions"] = Array();
				$row["Actions"][] = mkLink("index.php/admin/pages/edit/".$row["TextID"], _l("L_EDIT"));
				$row["Actions"][] = mkLink("modules/pages/main.act.php?action=delete&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1);
				if (!$row["Status"]) {
					$row["Actions"][] = mkLink("modules/pages/main.act.php?action=publish&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_PUBLISH"));
				}
				$row["Actions"] = mkButtonDisplay($row["Actions"]);

				$tpl->set_arr(
					$row,
					"PAGE"
				);
				$tpl->saveBuff("PAGE");
			}

			// Loading and setting up rtbEditor
			$rtb = new rtbEditor();
			$rtb->setSize(400, 350);

			$tpl->set_arr(
				Array (
					"BLOCK_TITLE" => _l("L_PAGES"),
					"BLOCK_SUBTITLE" => _l("L_PAGE_EDITOR"),
					"BLOCK_ICON" => mkIcon("pages.png", 16),
					"STATUS.SEL" => mkSelect(array(_l("L_DRAFT"), _l("L_PUBLISHED")), 1, "status"),
					"CATEGORIES.SEL" => mkSelect($categories, null, "category"),
					"PAGES" => $pages,
					"ACTION" => "create",
					"TITLE" => "",
					"CONTENT" => "",
					"ID" => 0,
					"RETURN" => "",
					"PAGER" => $pager["html"],
					"OPTIONS" => mkCheckBox("showtitle", _l("L_SHOW_TITLE"), 1),
					"RTBEDITOR" => $rtb->make()
				)
			);
			$mcBuff = $tpl->make();

		break;
	}
?>