<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";
	require_once GEKKO_ROOT."lib/core.lib.php";
	require_once GEKKO_ROOT."lib/format.lib.php";
	require_once GEKKO_ROOT."modules/pages/main.lib.php";

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	if (!gauth("pages")) abort(accessDenied());

	gpGet("action", 1);
	gpGet("id", 1);
	gpGet("return", 1);

	switch ($action) {
		case "delete":
			execWithEach($id, "deletePage");
		break;
		case "publish":
			pageSetStatus($id, 1);
		break;
		case "create":

			gpGlobalize("title, status, category, content, showtitle");

			requireVars($category, $title);

			rtb_codefix($content);

			$textid = mktextid($title, true);

			$db->query("SELECT ID FROM ".db_table("page")." WHERE TextID = '$textid'");
			if ($db->num_rows()) {
				abort(_l("E_DUPLICATED_PAGE"));
			}

			// inserting into database
			$db->query ("
			INSERT INTO ".db_table("page")."
				(
					ID,
					Category,
					TextID,
					Title,
					Content,
					AuthorID,
					Created,
					Modified,
					LastEditor,
					showTitle,
					Status
				)
					VALUES
				(
					'".$db->free_id("page")."',
					'{$category}',
					'{$textid}',
					'{$title}',
					'{$content}',
					'{$User["ID"]}',
					'".time()."',
					'".time()."',
					'{$User["ID"]}',
					'{$showtitle}',
					'{$status}'
				)
			", __FILE__, __LINE__);

			slog("pages: created -- '$title'", "actions", 1);

		break;
		case "edit":

			gpGlobalize("id, title, status, category, content, showtitle");

			requireVars($id, $category, $title);

			rtb_codefix($content);

			$textid = mktextid($title, true);

			$db->query("
				UPDATE ".db_table("page")." SET
					Category = '{$category}',
					TextID = '{$textid}',
					Title = '{$title}',
					Content = '{$content}',
					LastEditor = '{$User["ID"]}',
					Modified = '".time()."',
					showTitle = '{$showtitle}',
					Status = '{$status}'
				WHERE ID = '{$id}'
			", __FILE__, __LINE__);

			slog("pages: modified -- id='$id'", "actions", 2);
		break;
		default:
			abort(_l("L_UNDEFINED_ACTION"));
		break;
	}

	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>