<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";
	require_once GEKKO_ROOT."lib/core.lib.php";
	require_once GEKKO_ROOT."modules/polls/main.lib.php";

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	gpGet("action", 1);
	gpGet("id", 1);
	gpGet("return", 1);

	function validateOptions(&$optDescr) {
		/* counting not null options */
		$opts = 0;
		while (list($i) = each($optDescr)) {
			$opts += trim($optDescr[$i]) ? 1 : 0;
		}
		/* need at least two options */
		if ($opts < 2) abort(_l("E_INSUFFICIENT_DATA"));
		return true;
	}

	switch ($action) {
		case "createblock":

			gpGlobalize("id");

			requireVars ($id);

			require_once GEKKO_ROOT."modules/blocks/main.lib.php";

			$block_id = createSimpleBlock(_l("L_POLL"), "", "polls/show.php", "id={$id}", "polls.png");

			$return = "../../index.php/admin/blocks/edit/{$block_id}";

		break;
		case "vote":

			gpGlobalize("id, opt_id");

			requireVars($id, $opt_id);

			$id = intval($id);
			$opt_id = intval($opt_id);

			if (alreadyVoted($id)) {
				$return = "../../index.php/polls/view/?id=$id&message=".urlencode(_l("L_ALREADY_VOTED"))."";
			} else {
				$db->query("UPDATE ".db_table("polls")." SET
				OptVotes_{$opt_id} = OptVotes_{$opt_id}+1
				WHERE ID = '{$id}' AND OptDescr_{$opt_id} <> ''", __FILE__, __LINE__);

				/* ignoring votes for this user 24 hrs */
				$AccessTable->check("polls-vote-$id", POLL_VOTE_INTERVAL, 1);

				slog("polls: voted '$id'", 3);
			}

		break;
		case "edit":
			if (!is_admin())
				abort(accessDenied(true, __FILE__, __LINE__));

			gpGlobalize("id, title, description, category, optDescr, optVotes,
			status, expires, allowcomments, changeexpiration");

			requireVars($id, $title, $description, $category, $optDescr, $optVotes);

			validateOptions($optDescr);

			/* avoiding code repetition when updating fields  */
			$optFields = "";
			for ($i = 1; $i <= 10; $i++) {
				$optFields .= "OptDescr_$i = '".$optDescr[$i]."',\nOptVotes_$i = '".$optVotes[$i]."',\n";
			}

			/* updating database */
			$db->query("UPDATE ".db_table("polls")." SET
				Title = '{$title}',
				Description = '{$description}',
				Category = '{$category}',
				".($changeexpiration ? "Expires = '".getExpirationTime($expires)."'," : "")."
				$optFields
				AllowComments = '$allowcomments',
				Status = '{$status}'
			WHERE ID = '{$id}'", __FILE__, __LINE__);

			slog("polls: modified poll '$id'", "actions", 1);
		break;
		case "create":

			if (!is_admin())
				abort(accessDenied(true, __FILE__, __LINE__));

			gpGlobalize("title, description, category, optDescr, optVotes, status, expires, allowcomments");

			requireVars($title, $description, $category, $optDescr, $optVotes);

			validateOptions($optDescr);

			/* avoiding code repetition when inserting fields  */
			$optFields = "";
			$optValues = "";
			for ($i = 1; $i <= 10; $i++) {
				$optFields .= "OptDescr_$i,\nOptVotes_$i,\n";
				$optValues .= "'".$optDescr[$i]."',\n'".$optVotes[$i]."',\n";
			}

			/* creating poll */
			$db->query("
				INSERT INTO ".db_table("polls")." (
					ID,
					Category,
					Title,
					Description,
					AuthorID,
					Created,
					Expires,
					$optFields
					Status,
					AllowComments
				) VALUES (
					'".$db->free_id("polls")."',
					'{$category}',
					'{$title}',
					'{$description}',
					'{$User["ID"]}',
					'".time()."',
					'".getExpirationTime($expires)."',
					$optValues
					'{$status}',
					'{$allowcomments}'
				)
			");

			slog("polls: created poll '$title'", "actions", 1);
		break;
		default:
			abort(_l("L_UNDEFINED_ACTION"));
		break;
	}

	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>