<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/comments/main.lib.php";
	require_once GEKKO_ROOT."modules/categories/main.lib.php";
	require_once GEKKO_ROOT."modules/polls/main.lib.php";
	require_once GEKKO_ROOT."lib/chart.lib.php";

	$action = _ext("action", 1);
	$id = _ext("id", 2);

	$page = intval(_ext("page"));

	/* allowed categories */
	$cat_lock = getAllowedCategories(true);

	switch ($action) {
		case "view":

			// getting id
			$id = intval($id);
			if ($id < 1 || _ext("id")) $id = _ext("id");

			// getting page
			$page = _ext("page", 3);

			if ($id) {

				$db->query("SELECT * FROM ".db_table("polls")."
				WHERE ID = '{$id}' AND Status = '1' AND (Expires = '0' OR Expires < '".time()."') AND {$cat_lock}
				",__FILE__, __LINE__);

				if ($db->num_rows()) {
					$tpl = new ContentBlock();
					$tpl->insert("BLOCK_CONTENT", "polls/index.tpl");

					$row = $db->fetch_row();

					$expired = pollHasExpired($row["Expires"]);

					if ($expired || alreadyVoted($row["ID"]) ) {
						/* chart */
						$chart = new Chart("220px", true);

						for ($i = 1; $i <= 10; $i++) {
							if (trim($row["OptDescr_$i"])) {
								$chart->addItem($row["OptDescr_$i"], $row["OptVotes_$i"]);
							}
						}
						$tpl->set("POLL.CONTENT", $chart->make());
						unset($chart);
					} else {
						/* vote form */
						$tpl->insert("POLL.CONTENT", "polls/vote.form.tpl");
						for ($i = 1; $i <= 10; $i++) {
							if (trim($row["OptDescr_$i"])) {
								$tpl->set_arr(
									Array(
										"ID"=> $i,
										"OPTION" => $row["OptDescr_$i"]
									),
								"OPTION");
								$tpl->savebuff("OPTION");
							}
						}
					}

					$row["Category"] = getCategoryById($row["Category"]);
					$row["Expires"] = getExpirationDate($row["Expires"]);
					$row["Author"] = getUserById($row["AuthorID"]);

					$tpl->set_arr($row);

					$tpl->set_arr (
						Array (
							"BLOCK_ICON" => mkIcon("polls.png", 16),
							"BLOCK_TITLE" => _l("L_POLLS"),
							"BLOCK_SUBTITLE" => _l("L_VIEW_POLL"),
							"POLLS" => 0,
							"RETURN" => ""
						)
					);
					$mcBuff = $tpl->make();

					$mcBuff .= LoadCommentsBlock (
						"polls",
						$row["ID"],
						"index.php/polls/view/".urlencode($row["Title"])."?id={$row["ID"]}&page=%p",
						$page,
						$row["Title"]
					);

				} else {
					$mcBuff = "";
				}
			}
		break;
		default:
			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "polls/index.tpl");

			/* listing polls */
			$pager = $db->pager (
				"SELECT ID FROM ".db_table("polls")."
				WHERE Status = '1' AND (Expires = '0' OR Expires < '".time()."') AND {$cat_lock}",
				"index.php/polls?page=%p", $page, conf::getkey("polls", "items_per_page")
			);

			$db->query("SELECT * FROM ".db_table("polls")."
			WHERE Status = '1' AND (Expires = '0' OR Expires < '".time()."') AND {$cat_lock}
			ORDER BY Category ASC, Title ASC {$pager["sql"]}",
			__FILE__, __LINE__);

			$polls = $db->num_rows();
			while ($row = $db->fetch_row()) {
				$row["CommentsLink"] = mkCommentsLink("polls", $row["ID"], "index.php/polls/view/".urlencode($row["Title"])."?id=".$row["ID"]."");
				$row["Title"] = mkLink("index.php/polls/view/".urlencode($row["Title"])."?id=".$row["ID"]."", $row["Title"]);
				$row["Category"] = getCategoryById($row["Category"]);
				$row["Expires"] = getExpirationDate($row["Expires"]);
				$row["Author"] = getUserById($row["AuthorID"]);
				$tpl->set_arr($row, "POLL");
				$tpl->savebuff("POLL");
			}

			$tpl->set_arr (
				Array (
					"BLOCK_ICON" => mkIcon("polls.png", 16),
					"BLOCK_TITLE" => _l("L_POLLS"),
					"BLOCK_SUBTITLE" => _l("L_ACTIVE_POLLS"),
					"POLLS" => $polls,
					"PAGER" => $pager["html"],
					"ID" => 0,
					"RETURN" => ""
				)
			);

			$mcBuff = $tpl->make();
		break;
	}

	// saving buffer into modCore
	$mc->save($mcBuff);
?>