<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-BLOCK")) die();

	/*
	<%%>
	<?xml version="1.0" encoding="UTF-8"?>
	<blockscript>
		<info lang="en">
			<title><![CDATA[Who's online?]]></title>
			<description>Shows online users list</description>
			<author><![CDATA[xiam &lt;<a href="mailto:xiam@users.sourceforge.net">xiam@users.sourceforge.net</a>&gt;]]></author>
			<homepage><![CDATA[<a href="http://www.gekkoware.org">http://www.gekkoware.org</a>]]></homepage>
		</info>
		<info lang="es">
			<title><![CDATA[&iquest;Qui&eacute;nes est&aacute; en l&iacute;nea?]]></title>
			<description><![CDATA[Muestra la lista de usuarios en l&iacute;nea]]></description>
		</info>
	</blockscript>
	<%%>
	*/

	require_once GEKKO_ROOT."modules/users/main.lib.php";

	$return = Array();

	// seconds since last action to consider a user as online
	$alive = 300;

	// updating access
	accessControl::check(gauth("$") ? "$-".$GLOBALS["User"]["ID"] : "?-", $alive, -1);

	// getting users
	$q = $GLOBALS["db"]->query("SELECT AccessType FROM ".db_table("control")."
	WHERE SUBSTRING(AccessType, 1, 2) = '$-' AND Time > ".(time()-$alive)."", __FILE__, __LINE__, true);

	$usr = Array();
	while ($row = $GLOBALS["db"]->fetch_row($q)) {
		$uid = substr($row["AccessType"], 2);
		if (!isset($usr[$uid])) {
			$usr[$uid] = true;
		}
	}
	while (list($uid) = each($usr)) {
		$return[] = cache_func("getUserById($uid)");
	}

	// getting guests
	$q = $GLOBALS["db"]->query("SELECT IP FROM ".db_table("control")."
	WHERE AccessType = '?-' AND Time > ".(time()-$alive)."", __FILE__, __LINE__, true);

	// counting guests
	$guests = Array();
	while ($row = $GLOBALS["db"]->fetch_row($q)) {
		if (!isset($guests[$row["IP"]])) {
			$guests[$row["IP"]] = true;
		}
	}

	// commas are important :)
	$return = implode(", ", $return);

	if (($g = count($guests)) > 0) {
		$return .= ($return ? " ": "")."($g "._l("L_GUESTS").")";
	}
?>