<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/statistics/main.lib.php";

	// checking if user has been counted in the last 24 hours
	$first_visit = (!rcookie("counted"));

	if ($first_visit) {

		// user agent
		$userAgent = strtolower($_SERVER["HTTP_USER_AGENT"]);

		// guessing user agent
		$stats_user_agent_id = "_unknown";
		reset($stats_user_agent);
		while (list($id) = each($stats_user_agent)) {
			if (ereg($id, $userAgent)) {
				$stats_user_agent_id = $id;
				break;
			}
		}

		// guessing os
		$stats_os_id = "_unknown";
		reset($stats_os);
		while (list($id) = each($stats_os)) {
			if (ereg($id, $userAgent)) {
				$stats_os_id = $id;
				break;
			}
		}

		// counting visit, detailed mode
		list($month, $day, $year, $hour)  = explode("/", date("m/d/Y/H"));

		// increasing this hour visits counter
		$q = $db->query("UPDATE ".db_table("stats_visits")." SET
		H{$hour} = H{$hour} + 1, Total = Total + 1
		WHERE Month = '{$month}' AND Year = '{$year}' AND Day = '{$day}'",
		__FILE__, __LINE__, true);

		if (!$db->affected_rows($q)) {
			// this is the first visitor today
			$q = $db->query("INSERT INTO ".db_table("stats_visits")." (
				Year, Month, Day, H{$hour}, Total
			) VALUES (
				'{$year}', '{$month}', '{$day}', 1, 1
			)", __FILE__, __LINE__, true);
		}

		// increasing counters
		statsCounter::increase("user-agent", $stats_user_agent_id);
		statsCounter::increase("user-agent-os", $stats_os_id);
		statsCounter::increase("total", "unique-visits");

		// setting cookie, expires in 24 hours
		gcookie("counted", 1, 86400);
	}

	// increasing total clicks counter
	statsCounter::increase("total", "clicks");

	// logging urls

	sanitize($_SERVER["REQUEST_URI"]);
	sanitize($_SERVER["HTTP_REFERER"]);

	// referer log
	if (isset($_SERVER["HTTP_REFERER"]) && substr($_SERVER["HTTP_REFERER"], 0, strlen(_l("C_SITE.URL"))) != _l("C_SITE.URL")) {
		// updating counter
		$db->query("UPDATE ".db_table("stats_uri_logs")."
		SET Counter = Counter + 1, LastTime = '".time()."', LastIP = '".getIP()."'
		WHERE Type = 'referer' AND URL = '{$_SERVER["HTTP_REFERER"]}'
		", __FILE__, __LINE__);

		if (!$db->affected_rows()) {
			// counter doesn't exists, creating a new one
			$db->query("INSERT INTO ".db_table("stats_uri_logs")." (
				Type, URL, Counter, LastIP, LastTime
			) VALUES (
				'referer', '{$_SERVER["HTTP_REFERER"]}', 1, '".getIP()."', '".time()."'
			)");
		}
	}

	// hit log
	// updating counter
	$db->query("UPDATE ".db_table("stats_uri_logs")."
	SET Counter = Counter + 1, LastTime = '".time()."', LastIP = '".getIP()."'
	WHERE Type = 'request' AND URL = '{$_SERVER["REQUEST_URI"]}'
	", __FILE__, __LINE__);

	if (!$db->affected_rows()) {
		// counter doesn't exists, creating a new one
		$db->query("INSERT INTO ".db_table("stats_uri_logs")." (
			Type, URL, Counter, LastIP, LastTime
		) VALUES (
			'request', '{$_SERVER["REQUEST_URI"]}', 1, '".getIP()."', '".time()."'
		)");
	}


?>